//----------------------------------------------------------------
// Couple
// 	Oh!X 1990/12
// V3.20以降専用
//----------------------------------------------------------------
// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	// カード描画エリア
	CSX=112
	CEX=398
	CDWX=72
	CDWY=128
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(86):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE1,GPAGE0,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2)

apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

//----------------------------------------------------------------

dim int card(51),scrn(55)
dim str data(51)
int hy,frg,hip
int dm,mx,my,bl,br
int po1,kazu1,po2,kazu2
int num

//----------------------------------------------------------------

// 音声データ読み込み
int snd_pan=a_setPlayData("couple1.mp3")
int snd_pon=a_setPlayData("couple2.mp3")

init()
while 1
	cinit()
	game()
	gameover()
endwhile

// 音声バッファー開放
a_end(snd_pan)
a_end(snd_pon)
// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE0):bitmapClose()

end

//----------------------------------------------------------------

func init()
int x,y,c=0,i
//	screen 1,0,1,1	表示画面=512*512/実画面=1024*1024
	for y=0 to 63
		c=(y mod 2)*14:// 0 or 14
		for x=0 to 5
			if c=14 then c=0 else c=14
			fill16X68(x*16    ,y*16,x*16+    15,y*16+15,c)
			fill16X68(x*16+415,y*16,x*16+415+15,y*16+15,c)
		next
	next

	// 使用領域の下を緑で塗る
	setgPalet16X68(1,&h000000ff)
	apage(GPAGE2)
	gColor(&h00800080)
	fill(0,0,511,511)

	// 画面下半分を消す
	apage(GPAGE1)
	gColor(&h000000ff):// 不透明黒
	fill(0,512,511,1023)
	apage(GPAGE0)

//	window(CSX,0,CEX,1023)
	for i=0 to 51
		card(i)=i+1
		data(i)=utf8Hantozens(str$(i))
		if i<10 then {
			data(i)=" "+data(i)+" "
		}
	next
	tColorX68(7)
	gLocate( 2, 2):print"Ｃｏｕ";
	gLocate( 2, 3):print"　ｐｌｅ";
	gLocate( 2,22):print"Ｌｉｎｅ";
	gLocate( 2,27):print"Ｌａｓｔ";
	gLocate(54,29):print"Ｎｅｘｔ";
endfunc

//----------------------------------------------------------------

func cinit()
int a,b,c,i
	fill16X68(CSX,0,CEX,1023,0):// wipe()代わり
	for i=0 to 54:scrn(i)=54:next
	hip=-1:hy=0:frg=0:num=0
	score()
	gLocate(19,10):print"Ｔａｐ　Ｔｏ　Ｓｔａｒｔ";
	repeat
		a=rnd()*52
		b=rnd()*52
		c=card(a):card(a)=card(b):card(b)=c
	until getTouchStatus()<>TOUCH_NONE
	// タッチが離されるまで待つ
	while getTouchStatus()<>TOUCH_NONE
	endwhile
	gLocate(19,10):print space$(26);
	gLocate(19,11):print space$(26);:// Tapのpのディセンダー部分が残ってしまうので
endfunc

//----------------------------------------------------------------

func game()
	for num=0 to 51
		shori()
		while 1
			// タッチされるまで待つ
			repeat
			until getTouchStatus()<>TOUCH_NONE
			//
			dim float tpoint(1)
			int touchCnt=getTouchPoint(tpoint,1)
			mx=tpoint(0)
			my=tpoint(1)
			// タッチが離されるまで待つ
			while getTouchStatus()<>TOUCH_NONE
			endwhile
			//
			if mx>416 and my>432 and frg=0 then wait((42.0/500.0)/2.5):break:// "Next"
			if mx>=CSX and mx<=CEX then {
				// カード配置領域
				toru()
			}
			wait((42.0/500.0)*1.4)
		endwhile
	next
endfunc

//----------------------------------------------------------------

func toru()
int st,ch,d=1,i
int po
	po=(mx-CSX)/CDWX+(my/CDWY+hy/CDWY)*4:// position:左上から0〜
	switch frg
		case 0:// 1枚目設定
			//gLocate(0,35):print "1枚目設定/po=";po
			po1=po
			kazu1=scrn(po1) mod 13
			//gLocate(0,36):print "kazu1=";kazu1
			if scrn(po1)<54 then {
				//gLocate(40,36):print "set"
				set(po1,11)
				frg=1
			}
			break
		
		case 1:// 2枚目設定
			if po=po1 then {
				// 1枚目キャンセル
				set(po1,0)
				//gLocate(0,36):print "kazu1=cancel"
				//gLocate(40,36):print "   "
				frg=0
				break
			}
			//gLocate(0,35):print "2枚目設定/po=";po
			po2=po
			kazu2=scrn(po2) mod 13
			//gLocate(0,37):print "kazu2=";kazu2
			if setcheck()=0 then {
				// 2枚目が異なるときは選択しない
				//gLocate(20,35):print "2枚目が異なる"
				break
			}
			// 2枚目も同じ時
			//gLocate(40,37):print "set"
			set(po2,11)
			//gLocate(0,35):print "確定"
			frg=0
			if po1<po2 then {
				st=po1:ch=po2-1
			} else {
				st=po2:ch=po1-1
			}
			for i=st to hip-2
				if i=ch then d=2
				card_set(i,scrn(i+d))
			next
			card_set(hip-1,54)
			card_set(hip  ,54)
// スクロールの関係で、先に選択枠を消す
			set(po1,0)
			set(po2,0)
//
			if hip>15 and (hip mod 4)<2 then scroll(-1)
			hip=hip-2
			score()
			//
///			set(po1,0)
///			set(po2,0)
	endswitch
endfunc

//----------------------------------------------------------------

func set(po,c)
int x,y,sx,sy,ex,ey
	po=po-(hy/CDWY)*4:// スクロール対策
	x=(po mod 4)
	y=po/4
	sx=x*CDWX+118
	sy=(y*CDWY+  8):// mod 1024
	ex=x*CDWX+176
	ey=(y*CDWY+118):// mod 1024
	if c=0 then {
		lineWidth(3):/* こうしないと線が消えてくれない
		//gLocate(60,36):print "c=0  "
	} else {
		//gLocate(60,36):print "c=";c
	}
	box16X68(sx,sy,ex,ey,c)
	lineWidth(1)
endfunc
/*
//----------------------------------------------------------------

func card_set(po,n)
	//gLocate(0,39):print "card_set:n=";n
	a_play(snd_pon)
	scrn(po)=n
	//
	po=po-(hy/CDWY)*4:// スクロール対策
	int sx=(po mod 4)*CDWX+124
	int sy=(po/4*CDWY+16):// mod 1024
	card_print(sx,sy,n)
endfunc

func card_print(sx;int,sy;int,n;int)
	if n=54 then {
		// cput(54)で消すと、黒になってしまうので
		fill16X68(sx,sy,sx+CARD_WX-1,sy+CARD_WY-1,0)
	} else {
		cardPut(sx,sy,n,NO)
	}
endfunc

//----------------------------------------------------------------

func shori()
	hip=hip+1
	if hip>15 and (hip mod 4)=0 then scroll(+1)
	card_set(hip,card(num))
	score()
endfunc

//----------------------------------------------------------------

func score()
	gLocate(4,24):print data(hip/4+1);
	gLocate(4,29):print data(51-num);
endfunc

//----------------------------------------------------------------

func scroll(d;int)
// d=+1 下へ
// d=-1 上へ
int i,j,x,y,po
	if d=1 then {
		// 上スクロール
		hy=hy+CDWY
		po=(hy/CDWY)*4:// これで2ライン目の先頭
		for j=0 to 3:// 縦4ライン分
			x=124
			for i=0 to 3:// 横4枚
				y=(j*CDWY+16):// mod 1024
				if j=3 then {
					fill16X68(x,y,x+CARD_WX-1,y+CARD_WY-1,0)
				} else {
					cardPut(x,y,scrn(po),NO)
				}
				x=x+CDWX
				po=po+1
			next
		next
	} else {
		// 下スクロール
		hy=hy-CDWY
		po=(hy/CDWY)*4:// これで1ライン前の先頭
		for j=0 to 3:// 縦4ライン分
			x=124
			for i=0 to 3:// 横4枚
				y=(j*CDWY+16):// mod 1024
				card_print(x,y,scrn(po))
				x=x+CDWX
				po=po+1
			next
		next
	}
endfunc

//----------------------------------------------------------------

func setcheck()
int x1,y1,x2,y2
	if scrn(po2)<54 then {
		if kazu1=kazu2 then {
			if not(po1=po2) then {
				x1=po1 mod 4:y1=po1/4
				x2=po2 mod 4:y2=po2/4
				if x2>x1-2 and x2<x1+2 and y2>y1-2 and y2<y1+2 then return(1)
			}
		}
	}
	return(0)
endfunc

//----------------------------------------------------------------

func gameover()
str s
	fill16X68(CSX,0,CEX,1023,0)://wipe()
	if scrn(0)=54 then {
		s="CONGRATULATION"
	} else {
		s="    REGRET    "
	}
	symbol16X68(144,632-512,s,2,15,FONT,FNTSZ)
	hitKey(NO)
endfunc

//----------------------------------------------------------------
